# Numerous Apps

A powerful Python framework for building reactive web applications with simplicity at its core. Numerous Apps empowers developers to create modern, scalable web applications using familiar Python patterns while maintaining clean separation between business logic and presentation.

---

## Key Features

### 🚀 **Simple Yet Powerful**
- **Pure Python Development:** Write reactive web apps using standard Python - no special syntax or mixed-language files
- **Minimal Learning Curve:** If you know Python, you're ready to build web apps
- **Lightweight Core:** Less than 1000 lines of Python and 300 lines of JavaScript

### 🔧 **Modern Architecture**
- **Component-Based:** Built on [AnyWidgets](https://anywidgets.dev/) for reusable, framework-agnostic components
- **Clean Separation:** Python for logic, CSS for styling, Jinja2 for templates
- **Process Isolation:** Each session runs independently for better stability and scaling

### 🎨 **Full Creative Control**
- **Framework-Agnostic UI:** No imposed styling or components - complete freedom in design
- **Custom Widget Support:** Easily integrate your own HTML/CSS/JS components
- **Flexible Templating:** Use Jinja2 for powerful layout composition

### 💪 **Built for Scale**
- **Multi-Client Ready:** Built-in support for real-time collaborative applications
- **AI-Integration:** Seamless integration with AI agents and models
- **Developer-Friendly:** Use your favorite IDE and development tools
- **Built on FastAPI:** Leverage the speed and reliability of modern Python web frameworks
